<?php

/*
 * Copyright 2018, 1st Source IT, LLC, EZ Merchant Solutions
 * All rights reserved.
 * Resale prohibited.
 */
if( !defined('BOOTSTRAP') ) die('Access denied');

use Tygh\Registry;

function http2_fix_install() {
	$file = "app/Tygh/Http.php";
	$content = @file_get_contents($file);
	if( empty($content) ) {
		fn_set_notification('E', __("error"), "Can't open file '$file'.  Check permissions.", 'K');
		return;
	}
	if( strpos($content, 'EZms - Http2 Fix') || strpos($content, 'HTTP/2') ) {
		fn_set_notification("N", __("notice"), "Fix already applied", 'K');
		return;
	}
	if( $strpos = strpos($content, 'while (strpos(ltrim($content), \'HTTP/1\'') ) {
		$fix_str = "
// EZms - Http2 Fix
while (strpos(ltrim(\$content), 'HTTP/2') === 0) {
	list(self::\$_headers, \$content) = preg_split(\"/(\\r?\\n){2}/\", \$content, 2);
}
// End Http2 Fix
";

		$start_str = substr($content, 0, $strpos - 2);
		$end_str = substr($content, $strpos - 3);
		$fixed_content = sprintf("%s\n%s\n%s\n", $start_str, $fix_str, $end_str);
//trigger_error(substr($fixed_content, $strpos - 100, 1000));
//exit;
		$result = file_put_contents($file, $fixed_content);
		if( $result === false ) {
			fn_set_notification("E", __("error"), "Failed to update '$file', check permissions.", 'K');
			return;
		}
		fn_set_notification("N", __("notice"), "Patched file '$file'", 'K');
	}
}
?>